﻿using Dapper;
using Dm;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Linq;
using System.Runtime.ConstrainedExecution;
using System.Runtime.Remoting.Messaging;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;

/*Dapper是一个轻量级的ORM框架，现在使用的也很广泛，可以简化代码编写。因为Dapper扩展的IDbConnection，这是ADO.NET中的东西，我们使用的DmProvider也是实现了ADO.NET相关接口，所以Dapper可以通过DmProvider操作达梦数据库。*/
namespace netDemo
{
    class Dapper2
    {

        public class DmConnectionFactory
        {
            static string sqlConnString = "Server=127.0.0.1; UserId=SYSDBA; PWD=SYSDBA";
            public static IDbConnection GetConn()
            {
                return new DmConnection(sqlConnString);
            }
        }
       
        public static void Main()
        {
            Dapper2 dapper = new Dapper2();
            PersonModel model = new PersonModel();
         
            //插入数据
            model.Name = "dad";
            model.City = "dadafaf";
            dapper.Add(model);
            model.Name = "faf";
            model.City = "rqrqrqqr";
            dapper.Add(model);

            //获取数据
            model =dapper.Get(1);
            Console.WriteLine(model.ToString());
           
            
            //获取全部数据
            List<PersonModel> list = dapper.GetList();
            foreach (PersonModel model2 in list) {
                Console.WriteLine(model2.ToString());
            }
            

            //修改数据
            model.Name = "sdadfa";
            model.City = "wqrqr";
            model.Id = 1;   
            bool a=dapper.Update(model);
            Console.WriteLine(a);
        

            //删除数据
            bool b = dapper.Delete(2);
            Console.WriteLine(b);

            Console.ReadKey();

        }

  


        public PersonModel Get(int id)
        {
            string sql = "select Id,Name,City from Person where Id=:Id";
            return DmConnectionFactory.GetConn().QueryFirstOrDefault<PersonModel>(sql, new { Id = id });
        }

        public List<PersonModel> GetList()
        {
            string sql = "select Id,Name,City from Person";
            return DmConnectionFactory.GetConn().Query<PersonModel>(sql).ToList();
        }

        public int Add(PersonModel model)
        {
            string sql = "insert into Person(Name,City) Values(:Name,:City);Select @@IDENTITY";
            return DmConnectionFactory.GetConn().QuerySingle<int>(sql, model);
        }

        public bool Update(PersonModel model)
        {
            string sql = "update Person set City=:City where Id=:Id";
            int result = DmConnectionFactory.GetConn().Execute(sql, model);
            return result > 0;
        }

        public bool Delete(int id)
        {
            string sql = "delete from Person where Id=:Id";
            int result = DmConnectionFactory.GetConn().Execute(sql, new { Id = id });
            return result > 0;
        }


    }

    struct PersonModel
    {
        public int Id { set; get; }

        public string Name { set; get; }
        public string City { set; get; }
        public override string ToString() { return Id + "," + Name +"," + City; }


    }
}